/*
*  Copyright (C) 2007 David Chin, Vladimir Dergachev
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with with program; see the file COPYING. If not, write to the
*  Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
*  MA  02111-1307  USA
*/

/*
  File autogenerated by gengetopt version 2.11
  generated with the following command:
  gengetopt 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  compute time series of detector response function (antenna pattern). Outputs files with F+^2, Fx^2, (F+^2 + Fx^2); OR integrals of the above over the whole sky.\n"
  "\n"
  "Usage: %s [OPTIONS]...\n", CMDLINE_PARSER_PACKAGE);
  printf("\n");
  printf("  -h, --help                      Print help and exit\n");
  printf("  -V, --version                   Print version and exit\n");
  printf("\n");
  printf(" Group: single_src_or_whole_sky Single source or whole sky\n");
  printf("  -S, --single-source             Compute response with single source; \n                                    requires source data\n");
  printf("  -W, --whole-sky                 Compute response integrated over whole sky; \n                                    doesn't require source position\n");
  printf("\n");
  printf(" Group: output type Snapshot, time series, or average\n");
  printf("  -p, --snapshot                  Compute response at one instant in time\n");
  printf("  -t, --timeseries                Compute response at regularly spaced times\n");
  printf("  -a, --average                   Compute averaged response\n");
  printf("  -N, --source-name=STRING        Name of source  (default=`NONAME_SOURCE')\n");
  printf("  -r, --right-ascension=DOUBLE    Right Ascension of source, in rad\n");
  printf("  -d, --declination=DOUBLE        Declination of source, in rad\n");
  printf("  -o, --orientation=DOUBLE        Orientation of source, in rad\n");
  printf("  -D, --detector=STRING           Detector name; legal names: lho, llo, virgo, \n                                    geo, tama, cit, test\n");
  printf("  -s, --start-time-sec=INT        GPS seconds field of start time of \n                                    observation\n");
  printf("  -n, --start-time-nanosec=INT    GPS nanoseconds field of start time of \n                                    observation  (default=`0')\n");
  printf("  -u, --nsample=INT               number of samples\n");
  printf("  -i, --sampling-interval=DOUBLE  sampling time interval, in seconds\n");
  printf("      --n-ra=INT                  Number of grid points in RA  (default=`256')\n");
  printf("      --n-dec=INT                 Number of grid points in Dec  (default=`64')\n");
  printf("      --start-ra=INT              Starting RA index (>= 0)  (default=`0')\n");
  printf("      --count-ra=INT              Number of sub-grid points in RA\n");
  printf("      --start-dec=INT             Starting Dec index (>= 0)  (default=`0')\n");
  printf("      --count-dec=INT             Number of sub-grid points in Dec\n");
  printf("  -F, --format=STRING             output format  (default=`mam')\n");
  printf("  -O, --output-dir=STRING         Output directory  (default=`.')\n");
  printf("  -v, --verbosity=INT             verbosity level for debugging  (default=`0')\n");
  printf("  -e, --debug=INT                 debug level  (default=`0')\n");
  printf("      --earth-ephemeris=STRING    Earth ephemeris file\n");
  printf("      --sun-ephemeris=STRING      Sun ephemeris file\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;
  int output_type_group_counter = 0;
  
  int single_src_or_whole_sky_group_counter = 0;
  

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->single_source_given = 0 ;
  args_info->whole_sky_given = 0 ;
  args_info->snapshot_given = 0 ;
  args_info->timeseries_given = 0 ;
  args_info->average_given = 0 ;
  args_info->source_name_given = 0 ;
  args_info->right_ascension_given = 0 ;
  args_info->declination_given = 0 ;
  args_info->orientation_given = 0 ;
  args_info->detector_given = 0 ;
  args_info->start_time_sec_given = 0 ;
  args_info->start_time_nanosec_given = 0 ;
  args_info->nsample_given = 0 ;
  args_info->sampling_interval_given = 0 ;
  args_info->n_ra_given = 0 ;
  args_info->n_dec_given = 0 ;
  args_info->start_ra_given = 0 ;
  args_info->count_ra_given = 0 ;
  args_info->start_dec_given = 0 ;
  args_info->count_dec_given = 0 ;
  args_info->format_given = 0 ;
  args_info->output_dir_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->debug_given = 0 ;
  args_info->earth_ephemeris_given = 0 ;
  args_info->sun_ephemeris_given = 0 ;
#define clear_args() { \
  args_info->source_name_arg = gengetopt_strdup("NONAME_SOURCE") ;\
  args_info->detector_arg = NULL; \
  args_info->start_time_nanosec_arg = 0 ;\
  args_info->n_ra_arg = 256 ;\
  args_info->n_dec_arg = 64 ;\
  args_info->start_ra_arg = 0 ;\
  args_info->start_dec_arg = 0 ;\
  args_info->format_arg = gengetopt_strdup("mam") ;\
  args_info->output_dir_arg = gengetopt_strdup(".") ;\
  args_info->verbosity_arg = 0 ;\
  args_info->debug_arg = 0 ;\
  args_info->earth_ephemeris_arg = NULL; \
  args_info->sun_ephemeris_arg = NULL; \
}

  clear_args();

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "single-source",	0, NULL, 'S' },
        { "whole-sky",	0, NULL, 'W' },
        { "snapshot",	0, NULL, 'p' },
        { "timeseries",	0, NULL, 't' },
        { "average",	0, NULL, 'a' },
        { "source-name",	1, NULL, 'N' },
        { "right-ascension",	1, NULL, 'r' },
        { "declination",	1, NULL, 'd' },
        { "orientation",	1, NULL, 'o' },
        { "detector",	1, NULL, 'D' },
        { "start-time-sec",	1, NULL, 's' },
        { "start-time-nanosec",	1, NULL, 'n' },
        { "nsample",	1, NULL, 'u' },
        { "sampling-interval",	1, NULL, 'i' },
        { "n-ra",	1, NULL, 0 },
        { "n-dec",	1, NULL, 0 },
        { "start-ra",	1, NULL, 0 },
        { "count-ra",	1, NULL, 0 },
        { "start-dec",	1, NULL, 0 },
        { "count-dec",	1, NULL, 0 },
        { "format",	1, NULL, 'F' },
        { "output-dir",	1, NULL, 'O' },
        { "verbosity",	1, NULL, 'v' },
        { "debug",	1, NULL, 'e' },
        { "earth-ephemeris",	1, NULL, 0 },
        { "sun-ephemeris",	1, NULL, 0 },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVSWptaN:r:d:o:D:s:n:u:i:F:O:v:e:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'S':	/* Compute response with single source; requires source data.  */
          if (args_info->single_source_given)
            {
              fprintf (stderr, "%s: `--single-source' (`-S') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->single_source_given = 1;
          single_src_or_whole_sky_group_counter += 1;
        break;

        case 'W':	/* Compute response integrated over whole sky; doesn't require source position.  */
          if (args_info->whole_sky_given)
            {
              fprintf (stderr, "%s: `--whole-sky' (`-W') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->whole_sky_given = 1;
          single_src_or_whole_sky_group_counter += 1;
        break;

        case 'p':	/* Compute response at one instant in time.  */
          if (args_info->snapshot_given)
            {
              fprintf (stderr, "%s: `--snapshot' (`-p') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->snapshot_given = 1;
          output_type_group_counter += 1;
        break;

        case 't':	/* Compute response at regularly spaced times.  */
          if (args_info->timeseries_given)
            {
              fprintf (stderr, "%s: `--timeseries' (`-t') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->timeseries_given = 1;
          output_type_group_counter += 1;
        break;

        case 'a':	/* Compute averaged response.  */
          if (args_info->average_given)
            {
              fprintf (stderr, "%s: `--average' (`-a') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->average_given = 1;
          output_type_group_counter += 1;
        break;

        case 'N':	/* Name of source.  */
          if (args_info->source_name_given)
            {
              fprintf (stderr, "%s: `--source-name' (`-N') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->source_name_given = 1;
          if (args_info->source_name_arg)
            free (args_info->source_name_arg); /* free default string */
          args_info->source_name_arg = gengetopt_strdup (optarg);
          break;

        case 'r':	/* Right Ascension of source, in rad.  */
          if (args_info->right_ascension_given)
            {
              fprintf (stderr, "%s: `--right-ascension' (`-r') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->right_ascension_given = 1;
          args_info->right_ascension_arg = strtod (optarg, NULL);
          break;

        case 'd':	/* Declination of source, in rad.  */
          if (args_info->declination_given)
            {
              fprintf (stderr, "%s: `--declination' (`-d') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->declination_given = 1;
          args_info->declination_arg = strtod (optarg, NULL);
          break;

        case 'o':	/* Orientation of source, in rad.  */
          if (args_info->orientation_given)
            {
              fprintf (stderr, "%s: `--orientation' (`-o') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->orientation_given = 1;
          args_info->orientation_arg = strtod (optarg, NULL);
          break;

        case 'D':	/* Detector name; legal names: lho, llo, virgo, geo, tama, cit, test.  */
          if (args_info->detector_given)
            {
              fprintf (stderr, "%s: `--detector' (`-D') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->detector_given = 1;
          args_info->detector_arg = gengetopt_strdup (optarg);
          break;

        case 's':	/* GPS seconds field of start time of observation.  */
          if (args_info->start_time_sec_given)
            {
              fprintf (stderr, "%s: `--start-time-sec' (`-s') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->start_time_sec_given = 1;
          args_info->start_time_sec_arg = strtol (optarg,&stop_char,0);
          break;

        case 'n':	/* GPS nanoseconds field of start time of observation.  */
          if (args_info->start_time_nanosec_given)
            {
              fprintf (stderr, "%s: `--start-time-nanosec' (`-n') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->start_time_nanosec_given = 1;
          args_info->start_time_nanosec_arg = strtol (optarg,&stop_char,0);
          break;

        case 'u':	/* number of samples.  */
          if (args_info->nsample_given)
            {
              fprintf (stderr, "%s: `--nsample' (`-u') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->nsample_given = 1;
          args_info->nsample_arg = strtol (optarg,&stop_char,0);
          break;

        case 'i':	/* sampling time interval, in seconds.  */
          if (args_info->sampling_interval_given)
            {
              fprintf (stderr, "%s: `--sampling-interval' (`-i') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->sampling_interval_given = 1;
          args_info->sampling_interval_arg = strtod (optarg, NULL);
          break;

        case 'F':	/* output format.  */
          if (args_info->format_given)
            {
              fprintf (stderr, "%s: `--format' (`-F') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->format_given = 1;
          if (args_info->format_arg)
            free (args_info->format_arg); /* free default string */
          args_info->format_arg = gengetopt_strdup (optarg);
          break;

        case 'O':	/* Output directory.  */
          if (args_info->output_dir_given)
            {
              fprintf (stderr, "%s: `--output-dir' (`-O') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->output_dir_given = 1;
          if (args_info->output_dir_arg)
            free (args_info->output_dir_arg); /* free default string */
          args_info->output_dir_arg = gengetopt_strdup (optarg);
          break;

        case 'v':	/* verbosity level for debugging.  */
          if (args_info->verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg,&stop_char,0);
          break;

        case 'e':	/* debug level.  */
          if (args_info->debug_given)
            {
              fprintf (stderr, "%s: `--debug' (`-e') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->debug_given = 1;
          args_info->debug_arg = strtol (optarg,&stop_char,0);
          break;


        case 0:	/* Long option with no short option */
          /* Number of grid points in RA.  */
          if (strcmp (long_options[option_index].name, "n-ra") == 0)
          {
            if (args_info->n_ra_given)
              {
                fprintf (stderr, "%s: `--n-ra' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->n_ra_given = 1;
            args_info->n_ra_arg = strtol (optarg,&stop_char,0);
            break;
          }
          
          /* Number of grid points in Dec.  */
          else if (strcmp (long_options[option_index].name, "n-dec") == 0)
          {
            if (args_info->n_dec_given)
              {
                fprintf (stderr, "%s: `--n-dec' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->n_dec_given = 1;
            args_info->n_dec_arg = strtol (optarg,&stop_char,0);
            break;
          }
          
          /* Starting RA index (>= 0).  */
          else if (strcmp (long_options[option_index].name, "start-ra") == 0)
          {
            if (args_info->start_ra_given)
              {
                fprintf (stderr, "%s: `--start-ra' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->start_ra_given = 1;
            args_info->start_ra_arg = strtol (optarg,&stop_char,0);
            break;
          }
          
          /* Number of sub-grid points in RA.  */
          else if (strcmp (long_options[option_index].name, "count-ra") == 0)
          {
            if (args_info->count_ra_given)
              {
                fprintf (stderr, "%s: `--count-ra' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->count_ra_given = 1;
            args_info->count_ra_arg = strtol (optarg,&stop_char,0);
            break;
          }
          
          /* Starting Dec index (>= 0).  */
          else if (strcmp (long_options[option_index].name, "start-dec") == 0)
          {
            if (args_info->start_dec_given)
              {
                fprintf (stderr, "%s: `--start-dec' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->start_dec_given = 1;
            args_info->start_dec_arg = strtol (optarg,&stop_char,0);
            break;
          }
          
          /* Number of sub-grid points in Dec.  */
          else if (strcmp (long_options[option_index].name, "count-dec") == 0)
          {
            if (args_info->count_dec_given)
              {
                fprintf (stderr, "%s: `--count-dec' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->count_dec_given = 1;
            args_info->count_dec_arg = strtol (optarg,&stop_char,0);
            break;
          }
          
          /* Earth ephemeris file.  */
          else if (strcmp (long_options[option_index].name, "earth-ephemeris") == 0)
          {
            if (args_info->earth_ephemeris_given)
              {
                fprintf (stderr, "%s: `--earth-ephemeris' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->earth_ephemeris_given = 1;
            args_info->earth_ephemeris_arg = gengetopt_strdup (optarg);
            break;
          }
          
          /* Sun ephemeris file.  */
          else if (strcmp (long_options[option_index].name, "sun-ephemeris") == 0)
          {
            if (args_info->sun_ephemeris_given)
              {
                fprintf (stderr, "%s: `--sun-ephemeris' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->sun_ephemeris_given = 1;
            args_info->sun_ephemeris_arg = gengetopt_strdup (optarg);
            break;
          }
          

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */

  if ( output_type_group_counter > 1)
    {
      fprintf (stderr, "%s: %d options of group output type were given. At most one is required\n", CMDLINE_PARSER_PACKAGE, output_type_group_counter);
      missing_required_options = 1;
    }
  
  if ( single_src_or_whole_sky_group_counter != 1)
    {
      fprintf (stderr, "%s: %d options of group single_src_or_whole_sky were given. One is required\n", CMDLINE_PARSER_PACKAGE, single_src_or_whole_sky_group_counter);
      missing_required_options = 1;
    }
  

  if (! args_info->orientation_given)
    {
      fprintf (stderr, "%s: '--orientation' ('-o') option required\n", CMDLINE_PARSER_PACKAGE);
      missing_required_options = 1;
    }
  if (! args_info->detector_given)
    {
      fprintf (stderr, "%s: '--detector' ('-D') option required\n", CMDLINE_PARSER_PACKAGE);
      missing_required_options = 1;
    }
  if (! args_info->start_time_sec_given)
    {
      fprintf (stderr, "%s: '--start-time-sec' ('-s') option required\n", CMDLINE_PARSER_PACKAGE);
      missing_required_options = 1;
    }
  if ( missing_required_options )
    exit (EXIT_FAILURE);

  return 0;
}
